CREATE TABLE BANCOS (
    ID_BANCO INT PRIMARY KEY NOT NULL,
    CODIGO_BANCO INT NOT NULL,
    NOME_BANCO VARCHAR(100)
    
)

CREATE TABLE CONSOLIDACAO (
    ID_CONSOLIDACAO INT PRIMARY KEY NOT NULL,
    SALDO_ATUAL DECIMAL DEFAULT(0),
    SAQUES DECIMAL DEFAULT(0),
    DEPOSITOS DECIMAL DEFAULT(0),
    NUMERO_CORRENTISTA DECIMAL DEFAULT(0)
    
)

CREATE TABLE PAISES (
    ID_PAIS INT PRIMARY KEY NOT NULL,
    PAIS VARCHAR(255) NOT NULL
    
)

CREATE TABLE CADASTRO (
    ID_CADASTRO INT PRIMARY KEY NOT NULL,
    NOME VARCHAR(255) NOT NULL,
    CPF CHAR(11) NOT NULL,
    ESTADO_CIVIL VARCHAR(20) NOT NULL,
    DATA_NASC DATE NOT NULL
    
)

CREATE TABLE ENDERECO (
    ID_ENDERECO INT PRIMARY KEY NOT NULL,
    LOGRADOURO VARCHAR(255),
    NUMERO VARCHAR(10) NOT NULL,
    COMPLEMENTO VARCHAR(100) NOT NULL,
    CEP CHAR(8),
    BAIRRO VARCHAR(255),
    CIDADE VARCHAR(255),
    ESTADO VARCHAR(255),
    ID_PAIS INT NOT NULL,
    ID_CADASTRO INT NOT NULL,
    
    CONSTRAINT FK_ID_PAIS FOREIGN KEY (ID_PAIS) REFERENCES PAISES(ID_PAIS),
    CONSTRAINT FK_ID_CADASTRO FOREIGN KEY (ID_CADASTRO) REFERENCES CADASTRO(ID_CADASTRO)
)

CREATE TABLE AGENCIAS (
    ID_AGENCIA INT PRIMARY KEY NOT NULL,
    CODIGO_AGENCIA INT NOT NULL,
    NOME_AGENCIA VARCHAR(100),
    ID_BANCO INT NOT NULL,
    ID_ENDERECO INT NOT NULL,
    ID_CONSOLIDACAO INT NULL,
    
    CONSTRAINT FK_ID_BANCO FOREIGN KEY (ID_BANCO) REFERENCES BANCOS(ID_BANCO),
    CONSTRAINT FK_ID_ENDERECO FOREIGN KEY (ID_ENDERECO) REFERENCES ENDERECO(ID_ENDERECO),
    CONSTRAINT FK_ID_CONSOLIDACAO FOREIGN KEY (ID_CONSOLIDACAO) REFERENCES CONSOLIDACAO(ID_CONSOLIDACAO)
)

CREATE TABLE GERENTES (
    ID_GERENTE INT PRIMARY KEY NOT NULL,
    TIPO_GERENTE CHAR(2) NOT NULL,
    CODIGO_FUNCIONARIO INT NOT NULL,
    ID_CADASTRO INT NOT NULL,
    
    CONSTRAINT FK_ID_CADASTRO_GERENTE FOREIGN KEY (ID_CADASTRO) REFERENCES CADASTRO(ID_CADASTRO)
)

CREATE TABLE CLIENTES (
    ID_CLIENTE INT PRIMARY KEY NOT NULL,
    ID_CADASTRO INT NOT NULL,
    
    CONSTRAINT FK_ID_CADASTRO_CLIENTE FOREIGN KEY (ID_CADASTRO) REFERENCES CADASTRO(ID_CADASTRO)
)

CREATE TABLE TIPO_CONTA (
    ID_TIPO_CONTA INT PRIMARY KEY NOT NULL,
    NOME_TIPO_CONTA VARCHAR(255)
)

CREATE TABLE CONTA (
    ID_CONTA INT PRIMARY KEY NOT NULL,
    CODIGO_CONTA VARCHAR(255),
    ID_TIPO_CONTA INT NOT NULL,
    ID_AGENCIA INT NOT NULL,
    SALDO DECIMAL DEFAULT(0),
    
    CONSTRAINT FK_ID_TIPO_CONTA FOREIGN KEY (ID_TIPO_CONTA) REFERENCES TIPO_CONTA(ID_TIPO_CONTA)
)

CREATE TABLE MOVIMENTACAO (
    ID_MOVIMENTACAO INT PRIMARY KEY NOT NULL,
    DEBITO DECIMAL DEFAULT(0),
    CREDITO DECIMAL DEFAULT(0),
    ID_CONTA INT NOT NULL,
    
    CONSTRAINT FK_ID_CONTA FOREIGN KEY (ID_CONTA) REFERENCES CONTA(ID_CONTA)
)

CREATE TABLE CONTA_X_CLIENTE (
    ID_CONTA INT NOT NULL,
    ID_TIPO_CONTA INT NOT NULL,
    ID_GERENTE INT NOT NULL,
    ID_CLIENTE INT NOT NULL,
    
    CONSTRAINT FK_ID_CONTA_CXC FOREIGN KEY (ID_CONTA) REFERENCES CONTA(ID_CONTA),
    CONSTRAINT FK_ID_TIPO_CONTA_CXC FOREIGN KEY (ID_TIPO_CONTA) REFERENCES TIPO_CONTA(ID_TIPO_CONTA),
    CONSTRAINT FK_ID_GERENTE_CXC FOREIGN KEY (ID_GERENTE) REFERENCES GERENTES(ID_GERENTE),
    CONSTRAINT FK_ID_CLIENTE_CXC FOREIGN KEY (ID_CLIENTE) REFERENCES CLIENTES(ID_CLIENTE)
)
